#include <amxmodx>
#include <amxmisc>
#include <fakemeta>
#include <hamsandwich>
#include <cstrike>
#include <xs>
#include <orpheu>
#include <orpheu_stocks>
#include <engine>

#define PLUGIN "Czolganie"
#define VERSION "1.0"
#define AUTHOR "DarkGL"

#define IDLE_ANIMATION 1
#define CLIENT_ANIMATION 1
#define SWIM_ANIMATION 8

#define MAX 32

new bFreeze = false;

native codSetModel( id , szModel[] );
native codGetModel( id , szModel[] , len );
native setSpeed( id );
native bool: isSprint( id );

new const szModels[8][ 2 ][ 64 ]	= {
	{ "arctic" , "arctic_gwm" } ,
	{ "gign" , "gign_gwm" } ,
	{ "gsg9" , "gsg9_gwm" } ,
	{ "guerilla" , "guerilla_gwm" } ,
	{ "leet" , "leet_gwm" } ,
	{ "sas" , "sas_gwm" } ,
	{ "terror" , "terror_gwm" } ,
	{ "urban" , "urban_gwm" }
}

#define MAX_LEN 64

new const Float:g_fWeaponsSpeed[ ]={
	000.0,
	250.0, 000.0, 260.0, 250.0, 240.0, 
	250.0, 250.0, 240.0, 250.0, 250.0,                
	250.0, 250.0, 210.0, 240.0, 240.0,    
	250.0, 250.0, 210.0, 250.0, 220.0,              
	230.0, 230.0, 250.0, 210.0, 250.0,            
	250.0, 235.0, 221.0, 250.0, 245.0 
};

new bool:bCraw[ MAX + 1 ] ,
szOldModel[ MAX + 1 ][ MAX_LEN ];

new OrpheuFunction: hookAnim;

public plugin_init(){
	register_plugin(PLUGIN, VERSION, AUTHOR);
	
	RegisterHam( Ham_Spawn , "player" , "fwSpawned" , 1 );
	RegisterHam( Ham_Killed , "player" , "fwKilled" , 0 );
	
	register_clcmd( "czolganie" , "funcCzolganie" );
	
	register_forward(FM_AddToFullPack, "fwAddToFullPack", 1);
	register_forward(FM_UpdateClientData, "UpdateClientData_Post", 1)
	
	register_logevent("PoczatekRundy", 2, "1=Round_Start"); 
	register_event("HLTV", "NowaRunda", "a", "1=0", "2=0");

	hookAnim	=	OrpheuGetFunction( "WeaponAnim" , "CBasePlayer" );
	
	OrpheuRegisterHook( hookAnim , "animFunc" , OrpheuHookPre );
}

public plugin_natives(){
	register_native( "isCrawls" , "isCrawls" , 1 );
}

public bool: isCrawls( id ){
	return bCraw[ id ];
}

public OrpheuHookReturn:animFunc( id , anim ){
	
	if( is_user_connected( id ) && bCraw[ id ] ){
		return OrpheuSupercede;
	}
	return OrpheuIgnored;
}

public PoczatekRundy()  
{	
	bFreeze = false;
	
}

public NowaRunda()
{
	bFreeze = true;
}

public fwKilled( id ){
	if( !is_user_alive( id ) && bCraw[ id ] ){
		bCraw[ id ]	=	false;
		
		codSetModel( id , szOldModel[ id ] );
	}
}

public client_connect( id ){
	bCraw[ id ]	=	false;
}

public plugin_precache(){
	new szPath[ 128 ];
	
	for( new i = 0 ; i < 8 ; i++ ){
		formatex( szPath , charsmax( szPath ) , "models/player/%s/%s.mdl" , szModels[ i ][ 1 ] , szModels[ i ][ 1 ]);
		
		engfunc( EngFunc_PrecacheModel , szPath );
	}
}

public fwAddToFullPack(es_handle, e, ENT, HOST, hostflags, player, set){
	if( !player ) return FMRES_IGNORED;
	if( is_user_alive( ENT ) && bCraw[ ENT ] ) {
		new Float: fOrigin[ 3 ];
		
		pev( ENT , pev_origin , fOrigin );
		
		fOrigin[ 2 ]	-=	35.0;
		
		set_es( es_handle , ES_Origin , fOrigin );
		
		set_es( es_handle , ES_UseHull , 1 );
		
		return FMRES_HANDLED;
	}
	return FMRES_IGNORED;
}

public fwSpawned( id ){
	
	bCraw[ id ]	=	false;
	
	return HAM_IGNORED;
}

public funcCzolganie( id ){
	if( !is_user_alive( id ) || bFreeze || isSprint( id ) )	return PLUGIN_HANDLED;
	
	new iFlags	=	pev( id , pev_flags );
	
	if( !( iFlags & FL_ONGROUND ) || pev(id,pev_watertype) != -1 )
		return PLUGIN_HANDLED;
	
	bCraw[ id ]	=	!bCraw[ id ];
	
	if( bCraw[ id ] ){
		
		new bool: bFind	=	false;
		
		codGetModel( id , szOldModel[ id ] , MAX_LEN - 1 );
		
		for( new i = 0 ; i < 8 ; i++ ){
			if( equal( szOldModel[ id ] , szModels[ i ][ 0 ] ) ){
				
				codSetModel( id , szModels[ i ][ 1 ] );
				
				bFind	=	true;
				
				break;
			}
		}
		
		if( !bFind ){
			codSetModel( id , cs_get_user_team( id ) == CS_TEAM_CT ? szModels[ 1 ][ 1 ] : szModels[ 4 ][ 1 ] );
		}
		
		set_pev( id , pev_framerate , 1.0 );
		set_pev( id , pev_animtime , get_gametime() );
		set_pev( id , pev_frame , 0.0 );
		
		set_pev( id , pev_sequence , CLIENT_ANIMATION );
		set_pev( id , pev_gaitsequence , CLIENT_ANIMATION );
		
	}
	else{
		codSetModel( id , szOldModel[ id ] );
		
		set_pev( id , pev_sequence , pev( id , pev_flags ) & FL_INWATER ? SWIM_ANIMATION : IDLE_ANIMATION );
		set_pev( id , pev_framerate , 1.0 );
		set_pev( id , pev_animtime , get_gametime() );
		
		engfunc( EngFunc_SetClientMaxspeed , id , g_fWeaponsSpeed[ get_user_weapon( id ) ] );
		
		if( pev( id , pev_flags ) & FL_DUCKING ){
			set_pev( id , pev_view_ofs , { 0.0 , 0.0 , 11.9 } );
		}
		else {
			set_pev( id , pev_view_ofs , { 0.0 , 0.0 , 16.9 } );
		}
		
		setSpeed( id );
	}
	
	return PLUGIN_HANDLED;
}

public UpdateClientData_Post( id, sendweapons, cd_handle ){
	if( !is_user_alive( id ) || !bCraw[ id ] ){
		return FMRES_IGNORED;
	}
	
	new Float: fOrigin[ 3 ];
	
	pev( id , pev_origin , fOrigin )
	
	fOrigin[ 2 ]	-=	35.0;
	
	set_cd( cd_handle , CD_Origin , fOrigin )
	set_cd( cd_handle , CD_ViewOfs , { 0.0 , 0.0 , 16.9 } );
	
	return FMRES_HANDLED;
}

public client_PreThink(id){	
	if( !is_user_alive( id ) || !bCraw[ id ] ){
		if( bCraw[ id ] )	bCraw[ id ]	=	false;
		
		return PLUGIN_CONTINUE;
	}
	
	new iFlags	=	pev( id , pev_flags );
	
	if( ( !( iFlags & FL_ONGROUND ) && !( iFlags & FL_PARTIALGROUND ) ) || pev(id,pev_watertype) != -1 || pev( id , pev_button ) & IN_JUMP || pev( id , pev_button ) & IN_DUCK ){
		
		bCraw[ id ]	=	false;
		
		codSetModel( id , szOldModel[ id ] );
		
		set_pev( id , pev_sequence , iFlags & FL_INWATER ? SWIM_ANIMATION : IDLE_ANIMATION );
		set_pev( id , pev_framerate , 1.0 );
		set_pev( id , pev_animtime , get_gametime() );
		
		engfunc( EngFunc_SetClientMaxspeed , id , g_fWeaponsSpeed[ get_user_weapon( id ) ] );
		
		if( pev( id , pev_flags ) & FL_DUCKING ){
			set_pev( id , pev_view_ofs , { 0.0 , 0.0 , 11.9 } );
		}
		else {
			set_pev( id , pev_view_ofs , { 0.0 , 0.0 , 16.9 } );
		}
		
		setSpeed( id );
		
		return PLUGIN_CONTINUE;
	}
	
	new Float: fVeloc[ 3 ];
	
	pev( id , pev_velocity , fVeloc );
	
	new Float: fSpeed	=	xs_vec_len( fVeloc );
	
	if( fSpeed >= 0.1 && pev( id , pev_framerate ) != 1.0 ){
		set_pev( id ,pev_framerate , 1.0 );
	}
	else if( fSpeed <= 0.1 && pev( id , pev_framerate ) == 1.0 ){
		set_pev( id , pev_framerate , 0.0 );
	}
	
	set_pev( id , pev_flTimeStepSound , 999 );
	set_pev( id , pev_maxspeed , 140.0 );
	
	set_pev( id , pev_view_ofs , { 0.0 , 0.0 , -18.1 } );
	
	engfunc( EngFunc_SetClientMaxspeed , id , 140.0 );
	
	return PLUGIN_CONTINUE;
}