/* Script generated by Pawn Studio */

#include <amxmodx>
#include <amxmisc>

#define PLUGIN	"New Plugin"
#define AUTHOR	"DarkGL"
#define VERSION	"1.0"

#define MAX 32

new const szFileWrite[]	=	"/modmanager.ini";
new szFilePath[ 256 ];

enum gameState {
	normalGame ,
	ctfGame
}

new gameState: currentState	=	normalGame;

new ctfPlugin;

new ctfOnForward;

new bool: heVoted[ MAX + 1 ];

new votesYes = 0;
new votesNo = 0;

new iTime = 10;

public plugin_init(){
	
	register_plugin( PLUGIN, VERSION, AUTHOR );
	
	get_configsdir( szFilePath , charsmax( szFilePath ) );
	
	add( szFilePath , charsmax( szFilePath ) , szFileWrite );
	
	set_task( 60.0 , "mapChange" , .flags = "d" );
}

public plugin_natives(){
	register_native( "isNormalGame" , "isNormal" , 1 );
	register_native( "isCtfGame" , "isCtf" , 1 );
	
	register_native( "registerCTFPlugin" , "registerCTFPlugin" , 0 );
}

public plugin_cfg(){
	
	if( !file_exists( szFilePath ) ){
		return ;
	}
	
	new szText[ 256 ] ,
		textLen;
	
	read_file( szFilePath , 0 , szText , charsmax( szText ) , textLen );
	
	delete_file( szFilePath );
	
	if( str_to_num( szText ) ){
		
		new iRet;
		
		setCtf();
		
		ExecuteForward( ctfOnForward , iRet );
		
	}
	
}

public isNormal(){
	return bool:( currentState == normalGame );
}

public isCtf(){
	return bool:( currentState == ctfGame );
}

public setCtf(){
	currentState	=	ctfGame;
}

public registerCTFPlugin( plugin , params ){
	ctfPlugin	=	plugin;
	
	ctfOnForward	=	CreateOneForward( ctfPlugin , "ctfOn" );
}

public mapChange(){
	
	menuDisplay();
	
	set_task( 1.0 , "timerCounting" , 1 , .flags = "b" );
}

public menuDisplay(){
	
	if( iTime < 0 ){
		return ;
	}
	
	new textItems[ 256 ];
	
	formatex( textItems , charsmax( textItems ) , "Gramy \rCTF ( Capture The Flag ) \wna nastepnej mapie ?^nZostalo %d czasu" , iTime );
	
	new pMenu = menu_create( textItems , "menuHandle" );
	
	formatex( textItems , charsmax( textItems ) , "Tak [\r%d\w]" , votesYes );
	menu_additem( pMenu , textItems );
	
	formatex( textItems , charsmax( textItems ) , "Nie [\r%d\w]" , votesNo );
	menu_additem( pMenu , textItems );
	
	menu_setprop( pMenu , MPROP_EXIT ,  MEXIT_NEVER );
	menu_setprop( pMenu , MPROP_NUMBER_COLOR , "\r" );
	menu_setprop( pMenu , MPROP_PERPAGE , 0 );
	
	menu_display( 0 , pMenu );
	
}

public menuHandle( id , menu , item ){
	
	if( heVoted[ id ] || iTime < 0 ){
		
		menuOperations( menu )
		
		return ;
	}
	
	heVoted[ id ]	=	true;
	
	switch( item ){
		case 0 : {
			votesYes++;
		}
		case 1 : {
			votesNo++;
		}
	}
	
	menuOperations( menu )
	
}

menuOperations( menu ){
	
	menu_destroy( menu );
	
	menuDisplay();
	
}

public timerCounting(){
	
	iTime--;
	
	if( iTime <= 0 ){
		remove_task( 1 );
		
		iTime = -1;
		
		countVotes();
	}
	
}

public countVotes(){
	if( votesYes > votesNo ){
		write_file( szFilePath , "1" );
		
		set_hudmessage( 0, 255, 0, -1.0, 0.28, 0, 5.0, 5.0)
		show_hudmessage( 0 , "Gramy CTF na nastepnej mapie")
	}
}