/* Script generated by Pawn Studio */

#include <amxmodx>
#include <amxmisc>
#include <fakemeta>
#include <fakemeta_util>
#include <hamsandwich>
#include <cstrike>
#include <fun>
#include <xs>
#include <engine>

#define PLUGIN	"CTF"
#define AUTHOR	"DarkGL"
#define VERSION	"1.0"

#define pev_state_current pev_iuser4
#define pev_state_default pev_iuser3
#define pev_endtime pev_fuser4
#define pev_users	pev_iuser2

#define ADMIN_FLAG ADMIN_IMMUNITY

#define flagClass	"ctfFlag"

new hudSync;

new Float:revivalTime[ 33 ];

new const flagModel[]	=	"models/csflags.mdl";

enum flagStateEnum {
	FLAG_NONE	=	0,
	FLAG_TT,
	FLAG_CT
}

new bool: bSave			=	false;

new iEntRespawn[ 33 ];

new szConfig[ 256 ];

new Array:ctFlags ,
	Array:ttFlags ,
	Array:noneFlags ;

new iPoints[ 2 ] = { 200 , 200 };
new iWin[ 2 ]	=	{ 0 , 0 };

new Float:fStarted;

new pCvarDistance;

public plugin_init(){
	register_plugin(PLUGIN, VERSION, AUTHOR);
	
	register_clcmd( "amx_flags_red" , "flagsRed" , ADMIN_FLAG );
	register_clcmd( "amx_flags_blue" , "flagsBlue" , ADMIN_FLAG );
	register_clcmd( "amx_flags_none" , "flagsNone" , ADMIN_FLAG );
	
	RegisterHam( Ham_Spawn , "player" , "fwSpawned" , .Post	=	true );
	
	register_event("DeathMsg", "DeathMsg", "a")
	
	ctFlags		=	ArrayCreate( 1 , 1 );
	ttFlags		=	ArrayCreate( 1 , 1 );
	noneFlags	=	ArrayCreate( 1 , 1 );
	
	register_event("HLTV", "newRound", "a", "1=0", "2=0")
	
	fStarted	=	get_gametime();
	
	register_think( flagClass , "thinkFlag" );
	
	pCvarDistance	=	register_cvar( "ctf_distance" , "100.0" );
	
	hudSync	=	CreateHudSyncObj()
}

public plugin_precache(){
	precache_model( flagModel );
}

public ctfOn(){
	loadConfig();
}

public loadConfig( ){
	formatex( szConfig[ get_configsdir( szConfig , charsmax( szConfig ) ) ] , charsmax( szConfig ) ,  "/ctf/" );
	
	if( !dir_exists( szConfig ) ){
		mkdir( szConfig );
		
		log_to_file( "addons/amxmodx/logs/ctf.log" , "Tworzenie folderu ctf" );
	}
	
	new szMapName[ 64 ];
	
	get_mapname( szMapName , charsmax( szMapName ) );
	
	add( szConfig , charsmax( szConfig ) , szMapName );
	add( szConfig , charsmax( szConfig ) , ".ini" );
	
	if( !file_exists( szConfig ) ){
		log_to_file( "addons/amxmodx/logs/ctf.log" , "Nie znaleziono pliku konfiguracyjnego dla %s" , szMapName );
		
		return PLUGIN_CONTINUE;
	}
	
	new szLine[ 256 ], iLen;
	
	for(new i = 0 ; read_file( szConfig , i, szLine, charsmax( szLine ), iLen) ; i++ ){
		new szOrigin[ 3 ][ 64 ] , szState[ 64 ];
		
		parse( szLine , szOrigin[ 0 ] , 63 , szOrigin[ 1 ] , 63 , szOrigin[ 2 ] , 63 , szState , charsmax( szState ) );
		
		new Float:fOrigin[ 3 ];
		
		fOrigin[ 0 ]	=	str_to_float( szOrigin[ 0 ] );
		fOrigin[ 1 ]	=	str_to_float( szOrigin[ 1 ] );
		fOrigin[ 2 ]	=	str_to_float( szOrigin[ 2 ] );
		
		createFlag( fOrigin , flagStateEnum:str_to_num( szState ) )
	}
	
	return PLUGIN_CONTINUE;
}

createFlag( Float:fOrigin[ 3 ] , flagStateEnum:flagState ){
	new iEnt	=	engfunc( EngFunc_CreateNamedEntity , engfunc( EngFunc_AllocString , "info_target" ) );
	
	if( !pev_valid( iEnt ) ){
		return PLUGIN_CONTINUE;
	}
	
	set_pev( iEnt , pev_classname , flagClass );
	set_pev( iEnt , pev_state_default , _:flagState );
	set_pev( iEnt , pev_state_current , _:flagState );
	set_pev( iEnt , pev_solid , SOLID_TRIGGER );
	set_pev( iEnt , pev_movetype , MOVETYPE_TOSS );
	
	new Float:fMins[ 3 ]	=	{ -2.0, -2.0, 0.0 }
	new Float:fMaxs[ 3 ]	=	{ 2.0, 2.0, 16.0 }
	
	engfunc( EngFunc_SetOrigin , iEnt , fOrigin );
	engfunc( EngFunc_SetSize , iEnt , fMins , fMaxs );
	engfunc( EngFunc_SetModel , iEnt , flagModel );
	
	set_pev( iEnt , pev_body , flagState );
	
	set_pev( iEnt , pev_sequence , 0 );
	set_pev( iEnt , pev_framerate , 1.0 );
	set_pev( iEnt , pev_animtime , get_gametime() );
	
	set_pev( iEnt, pev_nextthink , get_gametime() + 0.1 );
	
	ArrayPushCell( flagState == FLAG_NONE ? noneFlags : ( flagState == FLAG_CT ? ctFlags : ttFlags ) , iEnt );
	
	return PLUGIN_CONTINUE;
}

public plugin_end(){
	
	ArrayDestroy( ctFlags );
	ArrayDestroy( ttFlags );
	ArrayDestroy( noneFlags );
	
	if( !bSave ){
		return PLUGIN_CONTINUE;
	}
	
	if( file_exists( szConfig ) ){
		delete_file( szConfig );
	}
	
	new iEnt	=	-1;
	
	while( ( iEnt	=	engfunc( EngFunc_FindEntityByString , iEnt , "classname" ,flagClass ) ) != 0 ){
		if( !pev_valid( iEnt ) ){
			continue;
		}
		
		new szText[ 256 ] , Float:fOrigin[ 3 ];
		
		pev( iEnt , pev_origin , fOrigin );
		
		formatex( szText , charsmax( szText ) , "%f %f %f %d" , fOrigin[ 0 ] , fOrigin[ 1 ] , fOrigin[ 2 ] , pev( iEnt , pev_state_default ) );
		
		write_file( szConfig , szText );
	}
	
	return PLUGIN_CONTINUE;
}

public fwSpawned( id ){
	if( !is_user_alive( id ) ){
		return HAM_IGNORED;
	}
	
	cs_set_user_money( id , cs_get_user_money( id ) + 2000 );
	
	give_item(id,	"weapon_m3")
	give_item(id, 	"ammo_buckshot")
	give_item(id, 	"ammo_buckshot")
	give_item(id, 	"ammo_buckshot")
	give_item(id, 	"ammo_buckshot")
	
	give_item( id , cs_get_user_team( id ) == CS_TEAM_T ? "weapon_glock18" : "weapon_usp" );
	
	remove_task( id );
	remove_task( id + 666 );
	remove_task( id + 1222 );
	
	return HAM_IGNORED;
}

public DeathMsg(){
	new iVictim = read_data(2);
	new CsTeams: iTeam	=	cs_get_user_team( iVictim );
	
	if( is_user_alive( iVictim ) || ( iTeam != CS_TEAM_CT && iTeam != CS_TEAM_T ) ){
		return PLUGIN_CONTINUE;
	}
	
	if( iTeam == CS_TEAM_T && ArraySize( ttFlags ) == 0 ){
		return PLUGIN_CONTINUE;
	}
	
	if( iTeam == CS_TEAM_CT && ArraySize( ctFlags ) == 0 ){
		return PLUGIN_CONTINUE;
	}
	
	remove_task( iVictim );
	remove_task( iVictim + 666 );
	remove_task( iVictim + 1222 );
	
	set_task( 10.0 , "giveLife" , iVictim );
	
	iEntRespawn[ iVictim ]	=	0;
	
	set_hudmessage( 0, 255, 0, -1.0, 0.20, 0, 5.0, 5.0 )
	show_hudmessage( iVictim , "Odrodzisz sie za 10 sekund" )
	
	revivalTime[ iVictim ]	=	 get_gametime() + 10.0;
	
	set_task( 0.1 , "hudRefresh" , iVictim + 1222 , .flags = "b" );
	
	new iSize	=	0;
	
	switch( iTeam ){
		case CS_TEAM_T:{
			iSize	=	ArraySize( ttFlags );
		}
		case CS_TEAM_CT:{
			iSize	=	ArraySize( ctFlags );
		}
	}
	
	new szTmp[ 16 ] , szText[ 128 ];
	
	new pMenu	=	menu_create( "Wybierz flage do odrodzenia" , "flagOdrodzenieHandle" );
	
	for( new i = 0 ; i < iSize ; i++ ){
		formatex( szText , charsmax( szText ) , "Flaga %d" , i + 1 );
		
		szTmp = "";
		switch( iTeam ){
			case CS_TEAM_T:{
				num_to_str( ArrayGetCell( ttFlags , i ) , szTmp , charsmax( szTmp ) );
			}
			case CS_TEAM_CT:{
				num_to_str( ArrayGetCell( ctFlags , i ) , szTmp , charsmax( szTmp ) );
			}
		}
		
		menu_additem( pMenu , szText , szTmp );
	}
	
	menu_setprop( pMenu , MPROP_BACKNAME , "Wroc" );
	menu_setprop( pMenu , MPROP_EXITNAME , "Wyjscie" );
	menu_setprop( pMenu , MPROP_NEXTNAME , "Dalej" );
	
	menu_display( iVictim , pMenu );
	
	return PLUGIN_CONTINUE;
}

public hudRefresh( id ){
	id	-=	1222;
	
	if( is_user_alive( id ) || !is_user_connected( id ) ){
		remove_task( id + 1222 );
	}
	else{
		if( revivalTime[ id ] > get_gametime() ){
			set_hudmessage(255, 0, 0, 0.68, 0.15, 0, 1.0, 1.0);
			ShowSyncHudMsg( id , hudSync , "Odrodzisz sie za %0.1f sekund" , revivalTime[ id ] - get_gametime() );
		}
	}
}

public flagOdrodzenieHandle( id , menu , item ){
	if( item == MENU_EXIT ){
		menu_destroy( menu );
		return PLUGIN_HANDLED;
	}
	
	new data[6], iName[64]
	new acces, callback
	menu_item_getinfo(menu, item, acces, data,5, iName, 63, callback)
	
	new iEnt = str_to_num( data );
	
	if( !pev_valid( iEnt ) ){
		menu_destroy( menu );
		return PLUGIN_HANDLED;
	}
	
	if( cs_get_user_team( id ) == CS_TEAM_CT && pev( iEnt , pev_state_current ) != _:FLAG_CT ){
		menu_destroy( menu );
		return PLUGIN_HANDLED;
	}
	
	if( cs_get_user_team( id ) == CS_TEAM_T && pev( iEnt , pev_state_current ) != _:FLAG_TT ){
		menu_destroy( menu );
		return PLUGIN_HANDLED;
	}
	
	iEntRespawn[ id ]	=	iEnt;
	
	menu_destroy( menu );
	return PLUGIN_HANDLED;
}

public giveLife( id ){
	if( is_user_connected( id ) && !is_user_alive( id ) && ( cs_get_user_team( id ) == CS_TEAM_CT || cs_get_user_team( id ) == CS_TEAM_T )){
		
		new CsTeams: iTeam	=	cs_get_user_team( id );
		
		if( iTeam == CS_TEAM_T && ArraySize( ttFlags ) == 0 ){
			return PLUGIN_CONTINUE;
		}
		
		if( iTeam == CS_TEAM_CT && ArraySize( ctFlags ) == 0 ){
			return PLUGIN_CONTINUE;
		}
		
		remove_task( id + 666 );
		remove_task( id + 1222 );
		
		revivalTime[ id ]	=	0.0
		
		set_task( 0.1 , "setOrigin" , id + 666 );
	}
	
	return PLUGIN_CONTINUE;
}

public setOrigin( id ){
	id -= 666;
	
	new Float:fOrigin[ 3 ] , Float: fNewOrigin[ 3 ];
	
	if( iEntRespawn[ id ] != 0 && pev_valid( iEntRespawn[ id ] ) ){
		
		pev( iEntRespawn[ id ] , pev_origin , fOrigin );
		
		xs_vec_copy( fOrigin , fNewOrigin );
		
		fNewOrigin[ 2 ]	+=	75.0;
		
		new Float: fReturn[ 3 ];
		
		if( fm_trace_line( iEntRespawn[ id ] , fOrigin , fNewOrigin , fReturn ) != 0 ){
			set_hudmessage( 0, 255, 0, -1.0, 0.20, 0, 2.0, 2.0 )
			show_hudmessage( id , "Niestety nie udalo sie ciebie zrespic poczekaj chwile" )
			
			set_task( 0.1 , "setOrigin" , id + 666 );
			
			return PLUGIN_CONTINUE;
		}
		
		ExecuteHamB( Ham_CS_RoundRespawn , id );
		
		new iParam[ 4 ];
		iParam[ 0 ] = id;
		iParam[ 1 ] = _:fNewOrigin[ 0 ];
		iParam[ 2 ] = _:fNewOrigin[ 1 ];
		iParam[ 3 ] = _:fNewOrigin[ 2 ];
		
		remove_task( id + 666 );
		
		set_task( 0.5 , "setOrigin2" , id + 666 , iParam , 4 );
		
		iPoints[ _:cs_get_user_team( id ) - 1 ]--;
		
		checkPoints()
	}
	else{
		new CsTeams: iTeam	=	cs_get_user_team( id );
		
		if( iTeam == CS_TEAM_T && ArraySize( ttFlags ) == 0 ){
			set_task( 0.1 , "setOrigin" , id + 666 );
			
			return PLUGIN_CONTINUE;
		}
		
		if( iTeam == CS_TEAM_CT && ArraySize( ctFlags ) == 0 ){
			set_task( 0.1 , "setOrigin" , id + 666 );
			
			return PLUGIN_CONTINUE;
		}
		
		new iEnt;
		
		switch( iTeam ){
			case CS_TEAM_CT:{
				iEnt	=	ArrayGetCell( ctFlags , random_num( 0 , ArraySize( ctFlags ) - 1 ) );
			}
			case CS_TEAM_T:{
				iEnt	=	ArrayGetCell( ttFlags , random_num( 0 , ArraySize( ttFlags ) - 1) );
			}
		}
		
		if( !pev_valid( iEnt ) ){
			set_hudmessage( 0, 255, 0, -1.0, 0.20, 0, 2.0, 2.0 )
			show_hudmessage( id , "Niestety nie udalo sie ciebie zrespic poczekaj chwile" )
			
			set_task( 0.1 , "setOrigin" , id + 666 );
			
			return PLUGIN_CONTINUE;
		}
		
		pev( iEnt , pev_origin , fOrigin );
		
		xs_vec_copy( fOrigin , fNewOrigin );
		
		fNewOrigin[ 2 ]	+=	75.0;
		
		new Float: fReturn[ 3 ];
		
		if( fm_trace_line( iEnt , fOrigin, fNewOrigin , fReturn ) != 0 ){
			set_hudmessage( 0, 255, 0, -1.0, 0.20, 0, 2.0, 2.0 )
			show_hudmessage( id , "Niestety nie udalo sie ciebie zrespic poczekaj chwile" )
			
			set_task( 0.1 , "setOrigin" , id + 666 );
			
			return PLUGIN_CONTINUE;
		}
		
		ExecuteHamB( Ham_CS_RoundRespawn , id );
		
		new iParam[ 4 ];
		iParam[ 0 ] = id;
		iParam[ 1 ] = _:fNewOrigin[ 0 ];
		iParam[ 2 ] = _:fNewOrigin[ 1 ];
		iParam[ 3 ] = _:fNewOrigin[ 2 ];
		
		remove_task( id + 666 );
		
		set_task( 0.5 , "setOrigin2" , id + 666 , iParam , 4 );
		
		iPoints[ _:cs_get_user_team( id ) - 1 ]--;
		
		checkPoints()
	}
	
	return PLUGIN_CONTINUE;
}

public setOrigin2( iParam[] ){
	new Float:fOrigin[ 3 ];
	
	fOrigin[ 0 ] = Float:iParam[ 1 ];
	fOrigin[ 1 ] = Float:iParam[ 2 ];
	fOrigin[ 2 ] = Float:iParam[ 3 ];
	
	engfunc( EngFunc_SetOrigin ,  iParam[ 0 ] , fOrigin );
	set_pev( iParam[ 0 ] , pev_origin , fOrigin );
	
}


public flagsRed( id , level , cid ){
	if( !cmd_access( id , level , cid , 2 ) ){
		return PLUGIN_HANDLED;
	}
	
	new szCommand[ 64 ];
	
	read_argv( 1 , szCommand , charsmax( szCommand ) );
	
	remove_quotes( szCommand );
	
	if( equal( szCommand , "dodaj" ) ){
		bSave	=	true;
		
		new Float:fOrigin[ 3 ];
		
		pev( id , pev_origin , fOrigin );
		
		createFlag( fOrigin , FLAG_TT )
	}
	else if( equal( szCommand , "usun" ) ){
		bSave	=	true;
		
		ArrayClear( ttFlags );
		
		new iEnt	=	-1;
		
		while( ( iEnt	=	engfunc( EngFunc_FindEntityByString , iEnt , "classname" ,flagClass ) ) != 0 ){
			if( !pev_valid( iEnt ) || pev( iEnt , pev_state_default ) != _:FLAG_TT ){
				continue;
			}
			
			remove_entity( iEnt );
		}	
		
	}
	
	return PLUGIN_HANDLED;
}

public flagsBlue( id , level , cid ){
	if( !cmd_access( id , level , cid , 2 ) ){
		return PLUGIN_HANDLED;
	}
	
	new szCommand[ 64 ];
	
	read_argv( 1 , szCommand , charsmax( szCommand ) );
	
	remove_quotes( szCommand );
	
	if( equal( szCommand , "dodaj" ) ){
		bSave	=	true;
		
		new Float:fOrigin[ 3 ];
		
		pev( id , pev_origin , fOrigin );
		
		createFlag( fOrigin , FLAG_CT )
	}
	else if( equal( szCommand , "usun" ) ){
		bSave	=	true;
		
		ArrayClear( ctFlags );
		
		new iEnt	=	-1;
		
		while( ( iEnt	=	engfunc( EngFunc_FindEntityByString , iEnt , "classname" ,flagClass ) ) != 0 ){
			if( !pev_valid( iEnt ) || pev( iEnt , pev_state_default ) != _:FLAG_CT ){
				continue;
			}
			
			remove_entity( iEnt );
		}	
		
	}
	
	return PLUGIN_HANDLED;
}

public flagsNone( id , level , cid ){
	if( !cmd_access( id , level , cid , 2 ) ){
		return PLUGIN_HANDLED;
	}
	
	new szCommand[ 64 ];
	
	read_argv( 1 , szCommand , charsmax( szCommand ) );
	
	remove_quotes( szCommand );
	
	if( equal( szCommand , "dodaj" ) ){
		bSave	=	true;
		
		new Float:fOrigin[ 3 ];
		
		pev( id , pev_origin , fOrigin );
		
		createFlag( fOrigin , FLAG_NONE )
	}
	else if( equal( szCommand , "usun" ) ){
		bSave	=	true;
		
		ArrayClear( noneFlags );
		
		new iEnt	=	-1;
		
		while( ( iEnt	=	engfunc( EngFunc_FindEntityByString , iEnt , "classname" ,flagClass ) ) != 0 ){
			if( !pev_valid( iEnt ) || pev( iEnt , pev_state_default ) != _:FLAG_NONE ){
				continue;
			}
			
			remove_entity( iEnt );
		}	
		
	}
	
	return PLUGIN_HANDLED;
}

public newRound(){
	iPoints[ 0 ]	=	200;
	iPoints[ 1 ]	=	200;
	
	ArrayClear( ctFlags );
	ArrayClear( ttFlags );
	ArrayClear( noneFlags );
	
	new iEnt	=	-1;
	
	while( ( iEnt	=	engfunc( EngFunc_FindEntityByString , iEnt , "classname" ,flagClass ) ) != 0 ){
		if( !pev_valid( iEnt )){
			continue;
		}
		
		set_pev( iEnt , pev_state_current , pev( iEnt , pev_state_default ) );
		set_pev( iEnt , pev_body , pev( iEnt , pev_state_default ) );
		set_pev( iEnt , pev_users , 0);
		set_pev( iEnt , pev_endtime , 0.0 );
		
		ArrayPushCell( flagStateEnum:pev( iEnt , pev_state_default ) == FLAG_NONE ? noneFlags : ( flagStateEnum:pev( iEnt , pev_state_default ) == FLAG_CT ? ctFlags : ttFlags ) , iEnt );
		
	}
}


public checkPoints(){
	if( iPoints[ 0 ] <= 0 && iPoints[ 1 ] > 0){
		set_hudmessage( 0, 255, 0, -1.0, 0.20, 0, 6.0, 5.0 )
		show_hudmessage( 0 , "Wygralo CT !" )
		
		for( new i = 0 ; i < 33 ; i++ ){
			remove_task( i );
			remove_task( i + 666 );
			
			if( !is_user_alive( i ) || cs_get_user_team( i ) == CS_TEAM_CT ) {
				continue;
			}
			
			ExecuteHamB( Ham_TakeDamage , i , 0 , 0 , 99999.0 , ( 1 << 1 ) );
		}
		
		iWin[ 1 ]++;
		
		if( iWin[ 1 ] >= 2 ){
			new fEnd	= ( floatround( get_gametime() - fStarted ) / 60 ) + 1;
			
			server_cmd("mp_timelimit %d" , fEnd);
			server_exec()
			
			new szNext[ 64 ];
			get_cvar_string( "amx_nextmap", szNext , charsmax( szNext ) )
			
			server_cmd("changelevel ^"%s^"" , szNext);
			server_exec()
			
			client_print( 0 , print_chat , "Zmiana mapy w ciagu najblizszej minuty" );
		}
	}
	else if( iPoints[ 1 ] <= 0 && iPoints[ 0 ] > 0){
		set_hudmessage( 0, 255, 0, -1.0, 0.20, 0, 6.0, 5.0 )
		show_hudmessage( 0 , "Wygralo TT !" )
		
		for( new i = 0 ; i < 33 ; i++ ){
			remove_task( i );
			remove_task( i + 666 );
			
			if( !is_user_alive( i ) || cs_get_user_team( i ) == CS_TEAM_T ) {
				continue;
			}
			
			ExecuteHamB( Ham_TakeDamage , i , 0 , 0 , 99999.0 , ( 1 << 1 ) );
		}
		
		iWin[ 0 ]++;
		
		if( iWin[ 0 ] >= 2 ){
			new fEnd	= ( floatround( get_gametime() - fStarted ) / 60 ) + 1;
			
			server_cmd("mp_timelimit %d" , fEnd);
			server_exec()
			
			new szNext[ 64 ];
			get_cvar_string( "amx_nextmap", szNext , charsmax( szNext ) )
			
			server_cmd("changelevel ^"%s^"" , szNext);
			server_exec()
			
			client_print( 0 , print_chat , "Zmiana mapy w ciagu najblizszej minuty" );
		}
	}
}

public thinkFlag( iEnt ){
	if( !pev_valid ( iEnt ) ){
		return PLUGIN_CONTINUE;
	}
	
	new bool:bFindTT , bool: bFindCT ;
	
	for( new i = 1 ; i < 33 ; i++ ){
		if( !is_user_alive( i ) ){
			continue;
		}
		
		if( fm_entity_range( i , iEnt ) <= get_pcvar_float( pCvarDistance ) ){
			switch( cs_get_user_team( i ) ){
				case CS_TEAM_CT:{
					bFindCT	=	true;
				}
				case CS_TEAM_T:{
					bFindTT	=	true;
				}
			}
		}
	}
	
	if( pev( iEnt , pev_state_current ) == _:FLAG_CT && bFindTT && !bFindCT){
		if( pev( iEnt , pev_endtime ) == 0.0 ){
			set_pev( iEnt , pev_endtime , get_gametime() + 25.0 );
		}
		
		new iUsers	=	0;
		
		for( new i = 1 ; i < 33 ; i++ ){
			if( !is_user_alive( i ) || cs_get_user_team( i ) != CS_TEAM_T){
				continue;
			}
			
			if( fm_entity_range( i , iEnt ) <= get_pcvar_float( pCvarDistance )){
				
				iUsers	|=	( 1 << i );
				
				set_hudmessage( 0, 255, 0, -1.0, 0.20, 0, 6.0, 5.0 )
				show_hudmessage( i , "Przejmowanie flagi" )
				
				if( !( pev( iEnt , pev_users ) & ( 1 << i ) ) ){
					
					set_bartime( i , 25 , floatround( ( ( 25.0 - ( pev( iEnt , pev_endtime ) - get_gametime() ) ) * 100.0 ) / 25.0 ) );
				}
			}
			
			if( pev( iEnt , pev_users ) & ( 1 << i ) && fm_entity_range( i , iEnt ) > get_pcvar_float( pCvarDistance ) ){
				set_bartime( i , 0 , 100 );
			}
		}
		
		set_pev( iEnt , pev_users , iUsers );
	}
	
	if( pev( iEnt , pev_state_current ) == _:FLAG_CT && ( !bFindTT  || bFindCT ) && pev( iEnt , pev_endtime ) != 0.0){
		set_pev( iEnt , pev_endtime , 0.0 );
		
		for( new i = 1 ; i < 33 ; i++ ){
			if( !is_user_alive( i ) || cs_get_user_team( i ) != CS_TEAM_T || !( pev( iEnt , pev_users ) & ( 1 << i ) )){
				continue;
			}
			
			set_bartime( i , 0 , 100 );
		}
		
		set_pev( iEnt , pev_users , 0 );
	}
	
	if( pev( iEnt , pev_state_current ) == _:FLAG_TT && !bFindTT && bFindCT ){
		if( pev( iEnt , pev_endtime ) == 0.0 ){
			set_pev( iEnt , pev_endtime , get_gametime() + 25.0 );
		}
		
		new iUsers	=	0;
		
		for( new i = 1 ; i < 33 ; i++ ){
			if( !is_user_alive( i ) || cs_get_user_team( i ) != CS_TEAM_CT){
				continue;
			}
			
			if( fm_entity_range( i , iEnt ) <= get_pcvar_float( pCvarDistance )){
				
				iUsers	|=	( 1 << i );
				
				set_hudmessage( 0, 255, 0, -1.0, 0.20, 0, 3.0, 3.0 )
				show_hudmessage( i , "Przejmowanie flagi" )
				
				if( !( pev( iEnt , pev_users ) & ( 1 << i ) ) ){
					set_bartime( i , 25 , floatround( ( ( 25.0 - ( pev( iEnt , pev_endtime ) - get_gametime() ) ) * 100.0 ) / 25.0 ) );
				}
			}
			
			if( pev( iEnt , pev_users ) & ( 1 << i ) && fm_entity_range( i , iEnt ) > get_pcvar_float( pCvarDistance ) ){
				set_bartime( i , 0 , 100 );
			}
		}
		
		set_pev( iEnt , pev_users , iUsers );
	}
	
	if( pev( iEnt , pev_state_current ) == _:FLAG_TT && ( !bFindCT  || bFindTT ) && pev( iEnt , pev_endtime ) != 0.0){
		set_pev( iEnt , pev_endtime , 0.0 );
		
		for( new i = 1 ; i < 33 ; i++ ){
			if( !is_user_alive( i ) || cs_get_user_team( i ) != CS_TEAM_CT || !( pev( iEnt , pev_users ) & ( 1 << i ) )){
				continue;
			}
			
			set_bartime( i , 0 , 100 );
		}
		
		set_pev( iEnt , pev_users , 0 );
	}
	
	new CsTeams: iTeam;
	
	if( bFindTT ) {
		iTeam	=	CS_TEAM_T;
	}
	else {
		iTeam	=	CS_TEAM_CT;
	}
	
	
	if( pev( iEnt , pev_state_current ) == _:FLAG_NONE && ( ( bFindTT && !bFindCT ) || ( !bFindTT && bFindCT ) )){
		if( pev( iEnt , pev_endtime ) == 0.0 ){
			set_pev( iEnt , pev_endtime , get_gametime() + 25.0 );
		}
		
		new iUsers	=	0;
		
		for( new i = 1 ; i < 33 ; i++ ){
			if( !is_user_alive( i ) || cs_get_user_team( i ) != iTeam){
				continue;
			}
			
			if( fm_entity_range( i , iEnt ) <= get_pcvar_float( pCvarDistance )){
				
				iUsers	|=	( 1 << i );
				
				if( !( pev( iEnt , pev_users ) & ( 1 << i ) ) ){
					set_hudmessage( 0, 255, 0, -1.0, 0.20, 0, 3.0, 3.0 )
					show_hudmessage( i , "Przejmowanie flagi" )
					
					set_bartime( i , 25 , floatround( ( ( 25.0 - ( pev( iEnt , pev_endtime ) - get_gametime() ) ) * 100.0 ) / 25.0 ) );
				}
			}
			
			if( pev( iEnt , pev_users ) & ( 1 << i ) && fm_entity_range( i , iEnt ) > get_pcvar_float( pCvarDistance ) ){
				set_bartime( i , 0 , 100 );
			}
		}
		
		set_pev( iEnt , pev_users , iUsers );
	}
	
	if( pev( iEnt , pev_state_current ) == _:FLAG_NONE && ( ( bFindCT  && bFindTT ) || ( !bFindCT && !bFindTT ) )&& pev( iEnt , pev_endtime ) != 0.0){
		set_pev( iEnt , pev_endtime , 0.0 );
		
		for( new i = 1 ; i < 33 ; i++ ){
			if( !is_user_alive( i ) || !( pev( iEnt , pev_users ) & ( 1 << i ) )){
				continue;
			}
			
			set_bartime( i , 0 , 100 );
		}
		
		set_pev( iEnt , pev_users , 0 );
	}
	
	if( pev( iEnt , pev_endtime ) <= get_gametime() && pev( iEnt , pev_endtime ) != 0.0 ){
		set_pev( iEnt , pev_endtime , 0.0 );
		
		if( bFindCT ){
			iTeam	=	CS_TEAM_CT;
		}
		else if( bFindTT ){
			iTeam	=	CS_TEAM_T;
		}
		
		if( pev( iEnt , pev_state_current ) == _:FLAG_CT || pev( iEnt , pev_state_current ) == _:FLAG_TT ){
			
			if( pev( iEnt , pev_state_current ) == _:FLAG_CT ){
				ArrayDelete( ctFlags , iEnt );
			}
			else 	if( pev( iEnt , pev_state_current ) == _:FLAG_TT ){
				ArrayDelete( ttFlags , iEnt );
			}
			
			set_pev( iEnt , pev_state_current , _:FLAG_NONE );
			set_pev( iEnt , pev_body , pev( iEnt , pev_state_current ) );
			
			ArrayPushCell( noneFlags , iEnt );
		}
		else{
			ArrayDelete( noneFlags , iEnt );
			
			switch( iTeam ){
				case CS_TEAM_CT:{
					set_pev( iEnt , pev_state_current , _:FLAG_CT );
					set_pev( iEnt , pev_body , pev( iEnt , pev_state_current ) );
					ArrayPushCell( ctFlags , iEnt );
				}
				case CS_TEAM_T:{
					set_pev( iEnt , pev_state_current , _:FLAG_TT );
					set_pev( iEnt , pev_body , pev( iEnt , pev_state_current ) );
					ArrayPushCell( ttFlags , iEnt );
				}
			}
		}
		
		for( new i = 1 ; i < 33 ; i++ ){
			if( !is_user_alive( i ) || 	!( pev( iEnt , pev_users ) & ( 1 << i ) )){
				continue;
			}
			
			set_bartime( i , 0 , 100 );
		}
		
		set_pev( iEnt , pev_users , 0 );
	}
	
	set_pev( iEnt, pev_nextthink , get_gametime() + 0.1 );
	
	return PLUGIN_CONTINUE;
}

stock set_bartime( id ,  czas, startprogress = 0 ){
	
	static msgBar;
	
	if( !msgBar )	msgBar	=	get_user_msgid("BarTime2");
	
	message_begin((id)?MSG_ONE:MSG_ALL, msgBar, .player = id)
	write_short(czas);
	write_short(startprogress);
	message_end();   
	
} 

stock ArrayDelete( Array:array , iItem ){
	for( new i = 0 ; i < ArraySize( array ) ; i++ ){
		if( ArrayGetCell( array , i ) == iItem ){
			ArrayDeleteItem( array , i );
			break;
		}
	}
}

